#include "Header.h"

void createFileWinApi(char* path)
{
	HANDLE FileTask;//  

	FileTask = CreateFileA(// 
		path, //
		GENERIC_READ | GENERIC_WRITE | GENERIC_ALL,//    
		FILE_SHARE_WRITE | FILE_SHARE_READ,//     
		NULL,//
		CREATE_ALWAYS,// -    
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,// 
		0);// 

	if (GetLastError() == 2)
	{
		printf("   \n");//   
		exit(1);// 
	}

	CloseHandle(FileTask);
}

void deleteFileWinApi(char* path)
{
	if (GetFileAttributesA(path) != -1)//  , ..   GetFileAttributesA != INVALID_FILE_ATTRIBUTES
	{
		DeleteFileA(path);// 
	}
}

void writeWinApi(char* path, char* str)
{
	deleteFileWinApi(path); //     
	createFileWinApi(path); //  

	HANDLE FileTask;//  

	FileTask = CreateFileA(// 
		path, //
		GENERIC_READ | GENERIC_WRITE | GENERIC_ALL,//    
		FILE_SHARE_WRITE | FILE_SHARE_READ,//     
		NULL,//
		CREATE_NEW,// -    
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,// 
		0);// 

	if (GetLastError() == 2)
	{
		printf("   \n");//   
		exit(1);// 
	}

	char* info_buf = calloc(1000, sizeof(char));
	char* buffer = calloc(strlen(str) + 1, sizeof(char)); //    

	FileTask = OpenFile(// 
		path,//  
		info_buf,//  
		OF_WRITE | OF_READWRITE);//     

	if (GetLastError() == -1)
	{
		printf("  ");
		exit(1);
	}

	WriteFile(//    
		FileTask,//
		str,//
		strlen(str),//
		NULL,// 
		NULL);// 

	if (GetLastError() == 6)//ERROR_INVALID_HANDLE -  
	{
		printf("O   \n");
		exit(6);
	}

	CloseHandle(FileTask);// 
}

char* readWinApi(char* path)
{
	HANDLE FileTask;//  

	FileTask = CreateFile(// 
		path, //
		GENERIC_READ | GENERIC_WRITE | GENERIC_ALL,//    
		FILE_SHARE_WRITE | FILE_SHARE_READ,//     
		NULL,//
		OPEN_EXISTING | OPEN_ALWAYS,// -    
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,// 
		0);// 

	if (GetLastError() == 2)
	{
		printf("   \n");//   
		exit(1);// 
	}

	char* info_buf = calloc(1000, sizeof(char));
	char* buffer = calloc(1000, sizeof(char)); //    

	FileTask = OpenFile(// 
		path,//  
		info_buf,//  
		OF_READ);//       

	if (GetLastError() == -1)
	{
		printf("  ");
		exit(1);
	}

	ReadFile(//  
		FileTask,//  
		buffer,//  
		1000,//     
		NULL,//   
		NULL);//   

	if (GetLastError() == 1784 || GetLastError() == 6)
	{
		printf("  ");
		exit(5);
	}

	CloseHandle(FileTask);// 

	return buffer;
}
